
/* define 'colorize' and 'colorizeDataSource' interfaces */

// 	'colorizeDataSource':
// 		'getHanZiNode',
// 		'getHanZiString',
// 		'setHanZiColorized',
// 
// 		'getPinYinNode',
// 		'getPinYinString',
// 		'setPinYinColorized'


/* search result data keeper class */
(function (window) {
var SearchResultKeeper = window.SearchResultKeeper = function (start, match) {
	this.start = start;
	this.match = match;
	this.length = match.length;

	return this;
};
})(window);

// Colorize class
(function (window) {
	var toneLabledLatinsTable = [
		null,     // [0]
		'āēūǖīō', // [1]
		'áéúǘíó', // [2]
		'ǎăěǔǚǐǒ', // [3]
		'àèùǜìò'  // [4]
	  ],
	  toneColors = [
		null,      // [0]
		'#F8C142', // [1]
		'#66CD3B', // [2]
		'#205CB5', // [3]
		'#ED3F27'  // [4]
	  ],
	  toneClasses = [
		  null,      // [0]
		  't1', // [1]
		  't2', // [2]
		  't3', // [3]
		  't4'  // [4]
	  ];

	Colorize = {};

	Colorize.hanZiNode = null;
	Colorize.pinYinNode = null;
	Colorize.dataSource = null; // implements colorizeDataSource Interface

	Colorize.setDataSource = function (obj) {
		Colorize.dataSource = obj;
	} // setDataSource

	// объявить раньше функции, чтобы избежать многократного разбора
	var list = ['zhuang','shuang','chuang','zhuan','zhuai','zhong','zheng','zhang','xiong','xiang','shuan','shuai','sheng','shang','qiong','qiang','niang','liang','kuang','jiong','jiang','huang','guang','chuan','chuai','chong','cheng','chang','zuan','zong','zhuo','zhun','zhui','zhua','zhou','zhen','zhei','zhao','zhan','zhai','zeng','zang','yuan','yong','ying','yang','xuan','xing','xiao','xian','weng','wang','tuan','tong','ting','tiao','tian','teng','tang','suan','song','shuo','shun','shui','shua','shou','shen','shei','shao','shan','shai','seng','sang','ruan','rong','reng','rang','quan','qing','qiao','qian','ping','piao','pian','peng','pang','nüe','nuan','nong','ning','niao','nian','neng','nang','ming','miao','mian','meng','mang','lüe','luan','long','ling','liao','lian','leng','lang','kuan','kuai','kong','keng','kang','juan','jing','jiao','jian','huan','huai','hong','heng','hang','guan','guai','gong','geng','gang','feng','fang','duan','dong','ding','diao','dian','deng','dang','cuan','cong','chuo','chun','chui','chua','chou','chen','chao','chan','chai','ceng','cang','bing','biao','bian','beng','bang','zuo','zun','zui','zou','zhu','zhi','zhe','zha','zen','zei','zao','zan','zai','yun','yue','you','yin','yao','yan','xun','xue','xiu','xin','xie','xia','wen','wei','wan','wai','tuo','tun','tui','tou','tie','tao','tan','tai','suo','sun','sui','sou','shu','shi','she','sha','sen','sei','sao','san','sai','ruo','run','rui','rua','rou','ren','rao','ran','qun','que','qiu','qin','qie','qia','pou','pin','pie','pen','pei','pao','pan','pai','nü','nuo','nou','niu','nin','nie','nen','nei','nao','nan','nai','mou','miu','min','mie','men','mei','mao','man','mai','lü','luo','lun','lou','liu','lin','lie','lia','lei','lao','lan','lai','kuo','kun','kui','kua','kou','ken','kei','kao','kan','kai','jun','jue','jiu','jin','jie','jia','huo','hun','hui','hua','hou','hng','hen','hei','hao','han','hai','guo','gun','gui','gua','gou','gen','gei','gao','gan','gai','fou','fen','fei','fan','duo','dun','dui','dou','diu','die','den','dei','dao','dan','dai','cuo','cun','cui','cou','chu','chi','che','cha','cen','cei','cao','can','cai','bin','bie','ben','bei','bao','ban','bai','ang','ê','zu','zi','ze','za','yu','yi','ye','ya','xu','xi','wu','wo','wa','tu','ti','te','ta','su','si','se','sa','ru','ri','re','qu','qi','pu','po','pi','pa','ou','nu','ni','ng','ne','na','mu','mo','mi','ma','lu','li','le','la','ku','ke','ka','ju','ji','hu','hm','he','ha','gu','ge','ga','fu','fo','fa','er','en','ei','du','di','de','da','cu','ci','ce','ca','bu','bo','bi','ba','ao','an','ai','o','n','m','e','a','r'];

	Colorize.splitPinYin = function (pinYin) {
		// алгоритм поиска 
		// 
		// +взять строку s, в которой, предположительно содержится пиньинь. 
		// :метка
		// +пропустить пробелы и апостроф в начале
		// +проверить, не пустая ли эта строка (перейти к выходу)
		// +взять список всех возможных пиньинь l
		// +найти в начале s слово из l
			// +перебирая по порядку элементы e из l
			// найти в начале s совпадение с e и выйти из цикла
		// +если не найдено, сообщить об ошибке в пиньине и закончить
		// +добавить найденное начало f в список результатов r
		// +вырезать f из s
		// +перейти на :метку
		// 
		// ++вернуть список r

		var result = [],
			py_plain = '';

		if (typeof pinYin !== 'string') {
			throw new Error('splitPinYin: argument is not a string');
		};
		
		// заменить тона в пиньинь для поиска
		py_plain = pinYin.toLowerCase()
		.replace(/[āáǎăà]/g, 'a').replace(/[ēéěè]/g, 'e')
		.replace(/[ōóǒò]/g, 'o').replace(/[ūúǔù]/g, 'u')
		.replace(/[ǖǘǚǜ]/g, 'u').replace(/[īíǐì]/g, 'i');

		// писать программу == программировать
		// скрипт 脚本 与 程序 有一个差别：把脚本可以写后马上开动，程序开动前一定要编码。

		/* :метка */
		for (var charPointer = 0; charPointer < py_plain.length; /**/ ) {
			if (py_plain[charPointer].search(/[a-z]/) == -1) {
				++charPointer;
				continue;
			};

			var found = null;
			for (var i = 0, e = ''; i < list.length; ++i) {
				e = list[i];
				if (py_plain.indexOf(e, charPointer) == charPointer) {
					found = e;
					break;
				};
			}; // for

			if (!found) {
				throw new Error('splitPinYin: something wrong with pin yin at index '+charPointer+', restWord: '+pinYin.slice(charPointer));
			};

			result.push(new SearchResultKeeper(charPointer, pinYin.slice(charPointer, charPointer+found.length)));
			charPointer += found.length;
		}

		return result;
	}; // splitPinYin

	Colorize.splitHanZi = function (hanZi) {
		var firstCharCode = 19968, // "一".charCodeAt()
			lastCharCode  = 40959, // code of last han zi in unicode
			result = [];

		for (var i = 0; i < hanZi.length; ++i) {
			var c = hanZi[i].charCodeAt();
			if (c >= firstCharCode && c <= lastCharCode || c >= '0'.charCodeAt() && c <= '9'.charCodeAt()) {
				result.push(new SearchResultKeeper(i, hanZi[i]));
			};
		};
		return result;
	}; // splitHanZi

	Colorize.determineTone = function (pinYinWord) {
		// для каждого тона
		for (var tone = 1; tone <= 4; ++tone) {
			toneStr = toneLabledLatinsTable[tone];
			for (var l = 0; l < toneStr.length; ++l) {
				if (pinYinWord.indexOf(toneStr[l]) != -1) {
					return tone;
				};
			};
		};
		return 0; // нулевой тон
	}; // determineTone

	// возвращает объект, содержащий два [object HTMLSpanElement]
	// в свойствах .hanZi и .pinYin
	Colorize.colorize = function (hanZiStr, pinYinStr) {
		var
		py_split = Colorize.splitPinYin(pinYinStr),
	    hz_split = Colorize.splitHanZi(hanZiStr),

	    pl = py_split.length,
	    hl = hz_split.length;

		if (hl == 0 || pl == 0) {
			throw new Error('colorize: no hanZi or no pinYin found!');
		};
	
	    var hanZiSpan, pinYinSpan;

		hanZiSpan = document.createElement('span');
		hanZiSpan.classList.add('hanZiWrapper');
		pinYinSpan = document.createElement('span');
		pinYinSpan.classList.add('pinYinWrapper');		

		var tones = [];
		for (var i = 0; i < pl; ++i) {
			// later use to colorize han zi
			tones.push(Colorize.determineTone(py_split[i].match));
		};

		var makeSpan = function (content, cl, parentNode) {
			var span = document.createElement('span');
			span.classList.add(cl);
			span.textContent = content;
			parentNode.appendChild(span);
		};

		for (var i = 0; i < pl; ++i) {
			var prev = py_split[i-1];
			// write non-pinyin symbols to the span
			// xss leak!
			pinYinSpan.innerHTML += pinYinStr.slice(
				(i == 0) ? 0 : (prev.start + prev.length),
				py_split[i].start);

			makeSpan(py_split[i].match, toneClasses[tones[i]], pinYinSpan);
		};
		// finaly
		var last_py = py_split[py_split.length-1];
		pinYinSpan.innerHTML += pinYinStr.slice(last_py.start + last_py.length);

		for (var i = 0; i < hl; ++i) {
			hanZiSpan.innerHTML += hanZiStr.slice(
				(i == 0) ? 0 : (hz_split[i-1].start + 1),
				hz_split[i].start
			);
			/* hz[i].length is always 1 */

			makeSpan(hz_split[i].match, toneClasses[tones[i]], hanZiSpan);
		}
		var last_hz = hz_split[hz_split.length-1];
		hanZiSpan.innerHTML += hanZiStr.slice(last_hz.start + last_hz.length);

		return {hanZi: hanZiSpan, pinYin: pinYinSpan};
	}; // colorize

	Colorize.exec = function () {
		if (!Colorize.dataSource) {
			throw new Error('exec: no dataSource set');
			window.Interface.insureImplements(Colorize.dataSource, window.interfaces.colorizeDataSource);
		};
		
		Colorize.hanZiNode  = Colorize.dataSource.getHanZiNode();
		Colorize.pinYinNode = Colorize.dataSource.getPinYinNode();

		var colored = Colorize.colorize(
			Colorize.dataSource.getHanZiString(Colorize.hanZiNode),
			Colorize.dataSource.getPinYinString(Colorize.pinYinNode)
		);

		Colorize.dataSource.setHanZiColorized(hanZiNode, colored.hanZi);
		Colorize.dataSource.setPinYinColorized(pinYinNode, colored.pinYin);
	};

	window.Colorize = Colorize;
})(window);


// ColorizeDictUni class
(function (window) {
	var ColorizeDictUni = {};

	ColorizeDictUni.getHanZiNode = function () {
		return (hanZiNode = document.getElementsByClassName('k')[0]);
	};

	ColorizeDictUni.getPinYinNode = function () {
		return (pinYinNode = document.getElementsByClassName('k')[0].nextSibling.nextSibling.nextSibling);
	};

	ColorizeDictUni.getHanZiString = 
	ColorizeDictUni.getPinYinString = function (node) {
		return node.textContent;
	};

	ColorizeDictUni.setHanZiColorized = function (node, newNode) {
		ColorizeDictUni.getHanZiNode().innerHTML = newNode.innerHTML;
	};

	ColorizeDictUni.setPinYinColorized = function (node, html) {
		var parentNode = node.parentNode;

		parentNode.insertBefore(html, node);
		parentNode.removeChild(node);
	};
	
	window.ColorizeDictUni = ColorizeDictUni;
})(window);

// ColorizeWeb class
(function (window) {
	var ColorizeWeb = {};

	ColorizeWeb.getHanZiNode = function () {
		return (hanZiNode = document.getElementById('ch'));
	};

	ColorizeWeb.getPinYinNode = function () {
		return (pinYinNode = document.getElementById('ch').parentNode.getElementsByClassName('py')[0].childNodes[0]);
	};

	ColorizeWeb.getHanZiString =
	ColorizeWeb.getPinYinString = function (node) {
		return node.textContent;
	};

	ColorizeWeb.setHanZiColorized = function (node, newNode) {
		ColorizeWeb.getHanZiNode().innerHTML = newNode.innerHTML;
	};

	ColorizeWeb.setPinYinColorized = function (node, html) {
		var parentNode = node.parentNode;

		parentNode.insertBefore(html, node);
		parentNode.removeChild(node);
	};
	
	window.ColorizeWeb = ColorizeWeb;
})(window);


if (window.location.hostname.indexOf('bkrs.info') != -1) {
	window.Colorize.setDataSource(window.ColorizeWeb);
} else if (window.location.protocol.indexOf('du-res:') != -1 ||
		   window.location.protocol.indexOf('file:')   != -1) {
	window.Colorize.setDataSource(window.ColorizeDictUni);
};

/* on ready function */
(function (window) {
	var funcDomReady='';

	var onDomReady = function (func) { // функция добавления события
	        var oldonload = funcDomReady;
	        if (typeof funcDomReady != 'function')
	                funcDomReady = func;
	        else {
	                funcDomReady = function() {
	                        oldonload();
	                        func();
	                }
	        }
	}

	// доступ к функции снаружи библиотеки
	window.onDomReady = onDomReady;

	function init() {
	    // выходим, если функция уже выполнялась
	    if (arguments.callee.done) return;

	    // устанавливаем флаг, чтобы функция не исполнялась дважды
	    arguments.callee.done = true;

	    if(funcDomReady)funcDomReady();	// вызываем всю цепочку обработчиков
	};

	/* для Mozilla/Firefox/Opera 9 */
	if (document.addEventListener)
	    document.addEventListener("DOMContentLoaded", init, false);

	/* для Internet Explorer */
	/*@cc_on @*/
	/*@if (@_win32)
	document.write("<script id=\"__ie_onload\" defer=\"defer\" src=\"javascript:void(0)\"><\/script>");
	var script = document.getElementById("__ie_onload");
	script.onreadystatechange = function() {
	    if (this.readyState == "complete")
	    init();
	}; // вызываем обработчик для onload
	/*@end @*/

	/* для Safari */
	if (/WebKit/i.test(navigator.userAgent)) { // условие для Safari
	    var _timer = setInterval(function() {
	    if (/loaded|complete/.test(document.readyState)) {
	        clearInterval(_timer);
	        init(); // вызываем обработчик для onload
	    }
	    }, 10);
	}

	/* для остальных браузеров */
	window.onload = init;
})(window);

window.onDomReady(window.Colorize.exec);
